#!/bin/bash
# generate_certs.sh
# Requires oqsprovider installed (dnf install oqsprovider)

# Generate CA
openssl genpkey -algorithm mldsa87 -out ca.key
openssl req -x509 -new -key ca.key -out ca.crt -subj "/CN=PQC CA"

# Generate server cert
openssl genpkey -algorithm mldsa44 -out server.key
openssl req -new -key server.key -out server.csr -subj "/CN=Post-Quantum Server"
openssl x509 -req -in server.csr -CA ca.crt -CAkey ca.key -CAcreateserial -out server.crt

# Generate client cert
openssl genpkey -algorithm mldsa87 -out client.key
openssl req -new -key client.key -out client.csr -subj "/CN=Post-Quantum Client"
openssl x509 -req -in client.csr -CA ca.crt -CAkey ca.key -CAcreateserial -out client.crt
